commit acfbc45886c4d81a2a3ca5af433a6124a0a7191a
Author: Marek Hulan <mhulan@redhat.com>
Date:   Wed Nov 20 10:58:13 2013 +0100

    fixes #812 - new permissions model, user group role and nest support, role filters for better granularity
    
    Contributions from:
    * Daniel Lobato <elobatocs@gmail.com>
    * Joseph Magen <jmagen@redhat.com>
    * Tom McKay <thomasmckay@redhat.com>
    * Greg Sutcliffe <gsutclif@redhat.com>
    * Dominic Cleal <dcleal@redhat.com>

diff --git a/.gitignore b/.gitignore
index 2b8191857..d7b5a6bfa 100644
--- a/.gitignore
+++ b/.gitignore
@@ -33,3 +33,5 @@ locale/*/LC_MESSAGES
 coverage/
 tags
 _build
+zeus.json
+custom_plan.rb
diff --git a/Gemfile b/Gemfile
index a4cb4aa84..6f7dfd80e 100644
--- a/Gemfile
+++ b/Gemfile
@@ -11,12 +11,13 @@ gem 'rest-client', :require => 'rest_client'
 gem "audited-activerecord", "3.0.0"
 gem "will_paginate", "~> 3.0.2"
 gem "ancestry", "~> 2.0"
-gem 'scoped_search', '>= 2.5'
+gem 'scoped_search', '>= 2.6.2'
 gem 'net-ldap'
 gem 'uuidtools'
 gem "apipie-rails", "~> 0.0.23"
 gem 'rabl', '>= 0.7.5', '<= 0.9.0'
 gem 'oauth'
+gem 'deep_cloneable'
 gem 'foreigner', '~> 1.4.2'
 
 if RUBY_VERSION =~ /^1\.8/
diff --git a/app/assets/javascripts/filters.js b/app/assets/javascripts/filters.js
new file mode 100644
index 000000000..ef04743c5
--- /dev/null
+++ b/app/assets/javascripts/filters.js
@@ -0,0 +1,15 @@
+$(document).ready(function () {
+  $('#filter_resource_type').change(function () {
+    $.ajax({
+      url: $(this).data('url'),
+      data: {
+        resource_type: $('#filter_resource_type').val()
+      },
+      dataType: "script"
+    });
+  });
+
+  $('#filter_unlimited').change(function () {
+    $('#search').prop('disabled', $(this).prop('checked'));
+  });
+});
diff --git a/app/controllers/about_controller.rb b/app/controllers/about_controller.rb
index e1acf7656..94b5e23e8 100644
--- a/app/controllers/about_controller.rb
+++ b/app/controllers/about_controller.rb
@@ -2,8 +2,8 @@ class AboutController < ApplicationController
   skip_before_filter :authorize, :only => :index
 
   def index
-    @proxies = SmartProxy.my_proxies.includes(:features)
-    @compute_resources = ComputeResource.my_compute_resources
+    @smart_proxies = SmartProxy.authorized(:view_smart_proxies).includes(:features)
+    @compute_resources = ComputeResource.authorized(:view_compute_resources)
     @plugins = Foreman::Plugin.all
   end
 
diff --git a/app/controllers/api/base_controller.rb b/app/controllers/api/base_controller.rb
index c58ea9104..824f4b9bf 100644
--- a/app/controllers/api/base_controller.rb
+++ b/app/controllers/api/base_controller.rb
@@ -43,8 +43,15 @@ module Api
       @resource_class ||= resource_name.classify.constantize
     end
 
-    def resource_scope
-      @resource_scope ||= resource_class.scoped
+    def resource_scope(controller = controller_name)
+      @resource_scope ||= begin
+        scope = resource_class.scoped
+        if resource_class.respond_to?(:authorized)
+          scope.authorized("#{action_permission}_#{controller}", resource_class)
+        else
+          scope
+        end
+      end
     end
 
     def api_request?
@@ -138,14 +145,15 @@ module Api
     #
     # example:
     # @host = Host.find_resource params[:id]
-    def find_resource
+    def find_resource(controller = controller_name)
       resource = resource_identifying_attributes.find do |key|
         next if key=='name' and (params[:id] =~ /\A\d+\z/)
         method = "find_by_#{key}"
         id = key=='id' ? params[:id].to_i : params[:id]
-        resource_scope.respond_to?(method) and
-          (resource = resource_scope.send method, id) and
-          break resource
+        scope = resource_scope(controller)
+        if scope.respond_to?(method)
+          (resource = scope.send method, id) and break resource
+        end
       end
 
       if resource
@@ -219,7 +227,10 @@ module Api
           if allowed_nested_id.include?(param)
             resource_identifying_attributes.each do |key|
               find_method = "find_by_#{key}"
-              @nested_obj ||= md[1].classify.constantize.send(find_method, params[param])
+              model = md[1].classify.constantize
+              controller = "#{md[1].pluralize}_#{controller_name}"
+              authorized_scope = model.authorized("#{action_permission}_#{controller}")
+              @nested_obj ||= authorized_scope.send(find_method, params[param])
             end
           else
             # there should be a route error before getting here, but just in case,
@@ -250,5 +261,19 @@ module Api
       []
     end
 
+    def action_permission
+      case params[:action]
+      when 'new', 'create'
+        'create'
+      when 'edit', 'update'
+        'edit'
+      when 'destroy'
+        'destroy'
+      when 'index', 'show', 'status'
+        'view'
+      else
+        raise ::Foreman::Exception.new(N_("unknown permission for %s"), "#{params[:controller]}##{params[:action]}")
+      end
+    end
   end
 end
diff --git a/app/controllers/api/v1/architectures_controller.rb b/app/controllers/api/v1/architectures_controller.rb
index 545075ddb..0a0c57a22 100644
--- a/app/controllers/api/v1/architectures_controller.rb
+++ b/app/controllers/api/v1/architectures_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @architectures = Architecture.includes(:operatingsystems).
+        @architectures = Architecture.
+          authorized(:view_architectures).
+          includes(:operatingsystems).
           search_for(*search_options).paginate(paginate_options)
       end
 
diff --git a/app/controllers/api/v1/audits_controller.rb b/app/controllers/api/v1/audits_controller.rb
index d070811e6..56d2f0b4a 100644
--- a/app/controllers/api/v1/audits_controller.rb
+++ b/app/controllers/api/v1/audits_controller.rb
@@ -12,7 +12,7 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        Audit.unscoped { @audits = Audit.search_for(*search_options).paginate(paginate_options) }
+        Audit.unscoped { @audits = Audit.authorized(:view_audit_logs).search_for(*search_options).paginate(paginate_options) }
       end
 
       api :GET, "/audits/:id/", "Show an audit"
diff --git a/app/controllers/api/v1/common_parameters_controller.rb b/app/controllers/api/v1/common_parameters_controller.rb
index 51fb944b5..e61f6dc3b 100644
--- a/app/controllers/api/v1/common_parameters_controller.rb
+++ b/app/controllers/api/v1/common_parameters_controller.rb
@@ -1,7 +1,7 @@
 module Api
   module V1
     class CommonParametersController < V1::BaseController
-      before_filter :find_resource, :only => [:show, :update, :destroy]
+      before_filter(:only => %w{show update destroy}) { find_resource('globals') }
 
       api :GET, "/common_parameters/", "List all common parameters."
       param :search, String, :desc => "filter results"
@@ -10,7 +10,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @common_parameters = CommonParameter.search_for(*search_options).paginate(paginate_options)
+        @common_parameters = CommonParameter.
+          authorized(:view_globals).
+          search_for(*search_options).
+          paginate(paginate_options)
       end
 
       api :GET, "/common_parameters/:id/", "Show a common parameter."
diff --git a/app/controllers/api/v1/compute_resources_controller.rb b/app/controllers/api/v1/compute_resources_controller.rb
index a956319b3..7bf52596c 100644
--- a/app/controllers/api/v1/compute_resources_controller.rb
+++ b/app/controllers/api/v1/compute_resources_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @compute_resources = ComputeResource.my_compute_resources.search_for(*search_options).paginate(paginate_options)
+        @compute_resources = ComputeResource.
+          authorized(:view_compute_resources).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/compute_resources/:id/", "Show an compute resource."
@@ -66,10 +68,6 @@ module Api
         process_response @compute_resource.destroy
       end
 
-      def resource_scope
-        resource_class.my_compute_resources
-      end
-
     end
   end
 end
diff --git a/app/controllers/api/v1/config_templates_controller.rb b/app/controllers/api/v1/config_templates_controller.rb
index c7885430b..9a655b430 100644
--- a/app/controllers/api/v1/config_templates_controller.rb
+++ b/app/controllers/api/v1/config_templates_controller.rb
@@ -3,7 +3,7 @@ module Api
     class ConfigTemplatesController < V1::BaseController
       include Foreman::Renderer
 
-      before_filter :find_resource, :only => [:show, :update, :destroy]
+      before_filter(:only => %w{show update destroy}) { find_resource('templates') }
       before_filter :handle_template_upload, :only => [:create, :update]
       before_filter :process_template_kind, :only => [:create, :update]
 
@@ -14,7 +14,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @config_templates = ConfigTemplate.search_for(*search_options).paginate(paginate_options).
+        @config_templates = ConfigTemplate.
+          authorized(:view_templates).
+          search_for(*search_options).paginate(paginate_options).
           includes(:operatingsystems, :template_combinations, :template_kind)
       end
 
@@ -61,7 +63,7 @@ module Api
       param :version, String, :desc => "template version"
 
       def revision
-        audit = Audit.find(params[:version])
+        audit = Audit.authorized(:view_audit_logs).find(params[:version])
         render :json => audit.revision.template
       end
 
@@ -75,7 +77,7 @@ module Api
       api :GET, "/config_templates/build_pxe_default", "Change the default PXE menu on all configured TFTP servers"
 
       def build_pxe_default
-        status, msg = ConfigTemplate.build_pxe_default(self)
+        status, msg = ConfigTemplate.authorized(:deploy_templates).build_pxe_default(self)
         render :json => msg, :status => status
       end
 
diff --git a/app/controllers/api/v1/domains_controller.rb b/app/controllers/api/v1/domains_controller.rb
index def3a6d2a..02ad341c9 100644
--- a/app/controllers/api/v1/domains_controller.rb
+++ b/app/controllers/api/v1/domains_controller.rb
@@ -22,7 +22,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @domains = Domain.search_for(*search_options).paginate(paginate_options)
+        @domains = Domain.
+          authorized(:view_domains).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/domains/:id/", "Show a domain."
diff --git a/app/controllers/api/v1/environments_controller.rb b/app/controllers/api/v1/environments_controller.rb
index 3fafb2f8c..23bbf5152 100644
--- a/app/controllers/api/v1/environments_controller.rb
+++ b/app/controllers/api/v1/environments_controller.rb
@@ -12,7 +12,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @environments = Environment.search_for(*search_options).paginate(paginate_options)
+        @environments = Environment.
+          authorized(:view_environments).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/environments/:id/", "Show an environment."
diff --git a/app/controllers/api/v1/fact_values_controller.rb b/app/controllers/api/v1/fact_values_controller.rb
index 65b990ff3..0d2cf4255 100644
--- a/app/controllers/api/v1/fact_values_controller.rb
+++ b/app/controllers/api/v1/fact_values_controller.rb
@@ -1,7 +1,6 @@
 module Api
   module V1
     class FactValuesController < V1::BaseController
-      before_filter :find_resource, :only => %w{show update destroy}
       before_filter :setup_search_options, :only => :index
 
       api :GET, "/fact_values/", "List all fact values."
@@ -12,7 +11,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        values = FactValue.my_facts.no_timestamp_facts.
+        values = FactValue.
+          authorized(:view_facts).
+          my_facts.
+          no_timestamp_facts.
           search_for(*search_options).paginate(paginate_options).
           includes(:fact_name, :host)
         render :json => FactValue.build_facts_hash(values.all)
diff --git a/app/controllers/api/v1/hostgroups_controller.rb b/app/controllers/api/v1/hostgroups_controller.rb
index f57b9012c..019d3c113 100644
--- a/app/controllers/api/v1/hostgroups_controller.rb
+++ b/app/controllers/api/v1/hostgroups_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @hostgroups = Hostgroup.includes(:hostgroup_classes, :group_parameters).
+        @hostgroups = Hostgroup.
+          authorized(:view_hostgroups).
+          includes(:hostgroup_classes, :group_parameters).
           search_for(*search_options).paginate(paginate_options)
       end
 
diff --git a/app/controllers/api/v1/hosts_controller.rb b/app/controllers/api/v1/hosts_controller.rb
index 014a59a4c..3da4e8954 100644
--- a/app/controllers/api/v1/hosts_controller.rb
+++ b/app/controllers/api/v1/hosts_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @hosts = Host.my_hosts.search_for(*search_options).paginate(paginate_options)
+        @hosts = Host.
+          authorized(:view_hosts, Host).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/hosts/:id/", "Show a host."
@@ -121,13 +123,12 @@ Return value may either be one of the following:
         render :json => { :status => @host.host_status }.to_json if @host
       end
 
-      # we need to limit resources for a current user
-      def resource_scope
-        resource_class.my_hosts
-      end
-
       private
 
+      def resource_scope(controller = controller_name)
+        Host.authorized("#{action_permission}_#{controller}", Host)
+      end
+
       # this is required for template generation (such as pxelinux) which is not done via a web request
       def forward_request_url
         @host.request_url = request.host_with_port if @host.respond_to?(:request_url)
diff --git a/app/controllers/api/v1/images_controller.rb b/app/controllers/api/v1/images_controller.rb
index 269ee76a1..a0298d428 100644
--- a/app/controllers/api/v1/images_controller.rb
+++ b/app/controllers/api/v1/images_controller.rb
@@ -12,7 +12,10 @@ module Api
       param :compute_resource_id, :identifier, :required => true
 
       def index
-        @images = @compute_resource.images.search_for(*search_options).paginate(paginate_options)
+        @images = @compute_resource.
+          images.
+          authorized(:view_images).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/compute_resources/:compute_resource_id/images/:id/", "Show an image"
@@ -65,7 +68,7 @@ module Api
       private
 
       def find_compute_resource
-        @compute_resource = ComputeResource.find(params[:compute_resource_id])
+        @compute_resource = ComputeResource.authorized(:view_compute_resources).find(params[:compute_resource_id])
       end
 
     end
diff --git a/app/controllers/api/v1/lookup_keys_controller.rb b/app/controllers/api/v1/lookup_keys_controller.rb
index 328593e74..b85ca5b08 100644
--- a/app/controllers/api/v1/lookup_keys_controller.rb
+++ b/app/controllers/api/v1/lookup_keys_controller.rb
@@ -1,7 +1,7 @@
 module Api
   module V1
     class LookupKeysController < V1::BaseController
-      before_filter :find_resource, :only => %w{show update destroy}
+      before_filter(:only => %w{show update destroy}) { find_resource('external_variables') }
       before_filter :setup_search_options, :only => :index
 
       api :GET, "/lookup_keys/", "List all lookup_keys."
@@ -11,7 +11,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @lookup_keys = LookupKey.search_for(*search_options).paginate(paginate_options)
+        @lookup_keys = LookupKey.
+          authorized(:view_external_variables).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/lookup_keys/:id/", "Show a lookup key."
diff --git a/app/controllers/api/v1/media_controller.rb b/app/controllers/api/v1/media_controller.rb
index 58c484929..1e1d3a510 100644
--- a/app/controllers/api/v1/media_controller.rb
+++ b/app/controllers/api/v1/media_controller.rb
@@ -30,7 +30,9 @@ Available families:
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @media = Medium.search_for(*search_options).paginate(paginate_options)
+        @media = Medium.
+          authorized(:view_media).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/media/:id/", "Show a medium."
diff --git a/app/controllers/api/v1/models_controller.rb b/app/controllers/api/v1/models_controller.rb
index e7d5d831c..4defc36d7 100644
--- a/app/controllers/api/v1/models_controller.rb
+++ b/app/controllers/api/v1/models_controller.rb
@@ -10,7 +10,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @models = Model.search_for(*search_options).paginate(paginate_options)
+        @models = Model.
+          authorized(:view_models).
+          search_for(*search_options).
+          paginate(paginate_options)
       end
 
       api :GET, "/models/:id/", "Show a model."
diff --git a/app/controllers/api/v1/operatingsystems_controller.rb b/app/controllers/api/v1/operatingsystems_controller.rb
index dbe268785..5e76efddf 100644
--- a/app/controllers/api/v1/operatingsystems_controller.rb
+++ b/app/controllers/api/v1/operatingsystems_controller.rb
@@ -16,6 +16,7 @@ module Api
 
       def index
         @operatingsystems = Operatingsystem.
+          authorized(:view_operatingsystems).
           includes(:media, :architectures, :ptables, :config_templates, :os_default_templates).
           search_for(*search_options).paginate(paginate_options)
       end
@@ -69,8 +70,8 @@ module Api
       param :architecture, String
 
       def bootfiles
-        medium = Medium.find_by_name(params[:medium])
-        arch   = Architecture.find_by_name(params[:architecture])
+        medium = Medium.authorized(:view_media).find_by_name(params[:medium])
+        arch   = Architecture.authorized(:view_architectures).find_by_name(params[:architecture])
         render :json => @operatingsystem.pxe_files(medium, arch)
       rescue => e
         render :json => e.to_s, :status => :unprocessable_entity
diff --git a/app/controllers/api/v1/ptables_controller.rb b/app/controllers/api/v1/ptables_controller.rb
index ef7c86bc9..e873b5ba5 100644
--- a/app/controllers/api/v1/ptables_controller.rb
+++ b/app/controllers/api/v1/ptables_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @ptables = Ptable.search_for(*search_options).paginate(paginate_options)
+        @ptables = Ptable.
+          authorized(:view_ptables).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/ptables/:id/", "Show a ptable."
diff --git a/app/controllers/api/v1/puppetclasses_controller.rb b/app/controllers/api/v1/puppetclasses_controller.rb
index e49cf8f0f..31f388e76 100644
--- a/app/controllers/api/v1/puppetclasses_controller.rb
+++ b/app/controllers/api/v1/puppetclasses_controller.rb
@@ -12,7 +12,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        values = Puppetclass.search_for(*search_options).paginate(paginate_options).
+        values = Puppetclass.
+          authorized(:view_puppetclasses).
+          search_for(*search_options).paginate(paginate_options).
           select([:name, :id]).
           includes(:lookup_keys)
         render :json => Puppetclass.classes2hash(values.all)
diff --git a/app/controllers/api/v1/reports_controller.rb b/app/controllers/api/v1/reports_controller.rb
index 89001a016..6117c4b08 100644
--- a/app/controllers/api/v1/reports_controller.rb
+++ b/app/controllers/api/v1/reports_controller.rb
@@ -11,7 +11,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @reports = Report.my_reports.includes(:logs => [:source, :message]).
+        @reports = Report.
+          authorized(:view_reports).
+          my_reports.
+          includes(:logs => [:source, :message]).
           search_for(*search_options).paginate(paginate_options)
       end
 
@@ -33,8 +36,8 @@ module Api
 
       def last
         conditions = { :host_id => Host.find_by_name(params[:host_id]).try(:id) } unless params[:host_id].blank?
-        max_id = Report.my_reports.where(conditions).maximum(:id)
-        @report = Report.includes(:logs => [:message, :source]).find(max_id)
+        max_id = Report.authorized(:view_reports).my_reports.where(conditions).maximum(:id)
+        @report = Report.authorized(:view_reports).includes(:logs => [:message, :source]).find(max_id)
         render :show
       end
 
diff --git a/app/controllers/api/v1/smart_proxies_controller.rb b/app/controllers/api/v1/smart_proxies_controller.rb
index b5342e446..1f03d3e1f 100644
--- a/app/controllers/api/v1/smart_proxies_controller.rb
+++ b/app/controllers/api/v1/smart_proxies_controller.rb
@@ -58,9 +58,18 @@ module Api
       end
 
       private
+      def action_permission
+        case params[:action]
+        when 'refresh'
+          :edit
+        else
+          super
+        end
+      end
+
       def proxies_by_type(type)
-        return SmartProxy.includes(:features).try(type.downcase+"_proxies") if not type.nil?
-        return SmartProxy.includes(:features).all
+        return SmartProxy.authorized(:view_smart_proxies).includes(:features).try(type.downcase+"_proxies") if not type.nil?
+        return SmartProxy.authorized(:view_smart_proxies).includes(:features).all
       end
 
       def check_feature_type
diff --git a/app/controllers/api/v1/statistics_controller.rb b/app/controllers/api/v1/statistics_controller.rb
index a56e533aa..e70fd087d 100644
--- a/app/controllers/api/v1/statistics_controller.rb
+++ b/app/controllers/api/v1/statistics_controller.rb
@@ -6,22 +6,22 @@ module Api
       api :GET, "/statistics/", "Get statistics"
 
       def index
-        @os_count    = Host.my_hosts.count_distribution :operatingsystem
-        @arch_count  = Host.my_hosts.count_distribution :architecture
-        @env_count   = Host.my_hosts.count_distribution :environment
-        @klass_count = Host.my_hosts.count_habtm "puppetclass"
-        @cpu_count   = FactValue.my_facts.count_each "processorcount"
-        @model_count = FactValue.my_facts.count_each "manufacturer"
-        @mem_size    = FactValue.my_facts.mem_average "memorysize"
-        @mem_free    = FactValue.my_facts.mem_average "memoryfree"
-        @swap_size   = FactValue.my_facts.mem_average "swapsize"
-        @swap_free   = FactValue.my_facts.mem_average "swapfree"
-        @mem_totsize = FactValue.my_facts.mem_sum "memorysize"
-        @mem_totfree = FactValue.my_facts.mem_sum "memoryfree"
-        render :json => { :statistics => { :os_count    => @os_count, :arch_count => @arch_count,
-                                            :env_count   => @env_count, :klass_count => @klass_count, :cpu_count => @cpu_count,
-                                            :model_count => @model_count, :mem_size => @mem_size, :mem_free => @mem_free, :swap_size => @swap_size,
-                                            :swap_free   => @swap_free, :mem_totsize => @mem_totsize, :mem_totfree => @mem_totfree } }
+        @os_count    = Host.authorized(:view_hosts).count_distribution :operatingsystem
+        @arch_count  = Host.authorized(:view_hosts).count_distribution :architecture
+        @env_count   = Host.authorized(:view_hosts).count_distribution :environment
+        @klass_count = Host.authorized(:view_hosts).count_habtm "puppetclass"
+        @cpu_count   = FactValue.authorized(:view_facts).my_facts.count_each "processorcount"
+        @model_count = FactValue.authorized(:view_facts).my_facts.count_each "manufacturer"
+        @mem_size    = FactValue.authorized(:view_facts).my_facts.mem_average "memorysize"
+        @mem_free    = FactValue.authorized(:view_facts).my_facts.mem_average "memoryfree"
+        @swap_size   = FactValue.authorized(:view_facts).my_facts.mem_average "swapsize"
+        @swap_free   = FactValue.authorized(:view_facts).my_facts.mem_average "swapfree"
+        @mem_totsize = FactValue.authorized(:view_facts).my_facts.mem_sum "memorysize"
+        @mem_totfree = FactValue.authorized(:view_facts).my_facts.mem_sum "memoryfree"
+        render :json => { :os_count    => @os_count,    :arch_count => @arch_count,   :swap_size => @swap_size,
+                          :env_count   => @env_count,   :klass_count => @klass_count, :cpu_count => @cpu_count,
+                          :model_count => @model_count, :mem_size => @mem_size,       :mem_free => @mem_free,
+                          :swap_free   => @swap_free,   :mem_totsize => @mem_totsize, :mem_totfree => @mem_totfree }
       end
 
     end
diff --git a/app/controllers/api/v1/subnets_controller.rb b/app/controllers/api/v1/subnets_controller.rb
index d79b03418..5ef0dcc91 100644
--- a/app/controllers/api/v1/subnets_controller.rb
+++ b/app/controllers/api/v1/subnets_controller.rb
@@ -11,7 +11,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @subnets = Subnet.includes(:tftp, :dhcp, :dns).
+        @subnets = Subnet.
+          authorized(:view_subnets).
+          includes(:tftp, :dhcp, :dns).
           search_for(*search_options).paginate(paginate_options)
       end
 
diff --git a/app/controllers/api/v1/usergroups_controller.rb b/app/controllers/api/v1/usergroups_controller.rb
index eafefc62a..bc96d1c59 100644
--- a/app/controllers/api/v1/usergroups_controller.rb
+++ b/app/controllers/api/v1/usergroups_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :order, String, :desc => "sort results"
 
       def index
-        @usergroups = Usergroup.search_for(*search_options).paginate(paginate_options)
+        @usergroups = Usergroup.
+          authorized(:view_usergroups).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/usergroups/:id/", "Show a usergroup."
diff --git a/app/controllers/api/v1/users_controller.rb b/app/controllers/api/v1/users_controller.rb
index 2827aac8d..0a0944d36 100644
--- a/app/controllers/api/v1/users_controller.rb
+++ b/app/controllers/api/v1/users_controller.rb
@@ -12,14 +12,15 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @users = User.search_for(*search_options).paginate(paginate_options)
+        @users = User.
+          authorized(:view_users).
+          search_for(*search_options).paginate(paginate_options)
       end
 
       api :GET, "/users/:id/", "Show an user."
       param :id, String, :required => true
 
       def show
-        @user
       end
 
       api :POST, "/users/", "Create an user."
diff --git a/app/controllers/api/v2/architectures_controller.rb b/app/controllers/api/v2/architectures_controller.rb
index 6c701b8a8..ce560a1ee 100644
--- a/app/controllers/api/v2/architectures_controller.rb
+++ b/app/controllers/api/v2/architectures_controller.rb
@@ -10,7 +10,9 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @architectures = Architecture.includes(:operatingsystems).
+        @architectures = Architecture.
+          authorized(:view_architectures).
+          includes(:operatingsystems).
           search_for(*search_options).paginate(paginate_options)
       end
 
diff --git a/app/controllers/api/v2/audits_controller.rb b/app/controllers/api/v2/audits_controller.rb
index 59612f4f2..402ceb85f 100644
--- a/app/controllers/api/v2/audits_controller.rb
+++ b/app/controllers/api/v2/audits_controller.rb
@@ -1,7 +1,8 @@
 module Api
   module V2
     class AuditsController < V2::BaseController
-      before_filter :find_resource, :only => %w{show update destroy}
+      before_filter :find_resource, :only => %w{show}
+      before_filter(:only => %w{show}) { find_resource('audit_logs') }
       before_filter :setup_search_options, :only => :index
 
       api :GET, "/audits/", "List all audits."
@@ -12,7 +13,7 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        Audit.unscoped { @audits = Audit.search_for(*search_options).paginate(paginate_options) }
+        Audit.unscoped { @audits = Audit.authorized(:view_audit_logs).search_for(*search_options).paginate(paginate_options) }
       end
 
       api :GET, "/audits/:id/", "Show an audit"
diff --git a/app/controllers/api/v2/common_parameters_controller.rb b/app/controllers/api/v2/common_parameters_controller.rb
index 18fcc2a29..2e9dce23c 100644
--- a/app/controllers/api/v2/common_parameters_controller.rb
+++ b/app/controllers/api/v2/common_parameters_controller.rb
@@ -2,7 +2,7 @@
 module Api
   module V2
     class CommonParametersController < V2::BaseController
-      before_filter :find_resource, :only => [:show, :update, :destroy]
+      before_filter(:only => %w{show update destroy}) { find_resource('globals') }
 
       api :GET, "/common_parameters/", "List all common parameters."
       param :search, String, :desc => "filter results"
@@ -11,7 +11,10 @@ module Api
       param :per_page, String, :desc => "number of entries per request"
 
       def index
-        @common_parameters = CommonParameter.search_for(*search_options).paginate(paginate_options)
+        @common_parameters = CommonParameter.
+          authorized(:view_globals).
+          search_for(*search_options).
+          paginate(paginate_options)
       end
 
       api :GET, "/common_parameters/:id/", "Show a common parameter."
diff --git a/app/controllers/api/v2/compute_resources_controller.rb b/app/controllers/api/v2/compute_resources_controller.rb
index c579fe37d..dc4f1af24 100644
--- a/app/controllers/api/v2/compute_resources_controller.rb
+++ b/app/controllers/api/v2/compute_resources_controller.rb
@@ -43,8 +43,8 @@ module Api
       param_group :compute_resource, :as => :create
 
       def create
-          @compute_resource = ComputeResource.new_provider(params[:compute_resource])
-          process_response @compute_resource.save
+        @compute_resource = ComputeResource.new_provider(params[:compute_resource])
+        process_response @compute_resource.save
       end
 
 
@@ -91,8 +91,15 @@ module Api
         render :available_storage_domains, :layout => 'api/v2/layouts/index_layout'
       end
 
-      def resource_scope
-        ComputeResource.my_compute_resources
+      private
+
+      def action_permission
+        case params[:action]
+          when 'available_images', 'available_clusters', 'available_networks', 'available_storage_domains'
+            :view
+          else
+            super
+        end
       end
     end
   end
